<template>
  <v-app>
    <v-navigation-drawer id="app-menu" v-model="drawer" fixed app>
      <app-menu />
      <template #append>
        <div class="pa-2 d-flex flex-column align-center">
          <v-img width="30%" />
        </div>
      </template>
    </v-navigation-drawer>
    <v-main :id="urlActual === 'index' ? 'app-page-content' : ''">
      <v-container fluid>
        <transition name="slide-fade">
          <nuxt v-if="mostrar" />
        </transition>
      </v-container>
    </v-main>
    <v-dialog v-model="AppLoading" persistent width="300">
      <v-card color="accent" dark>
        <v-card-text>
          {{ AppLoadingText }}
          <v-progress-linear indeterminate color="white" class="mb-0" />
        </v-card-text>
      </v-card>
    </v-dialog>
  </v-app>
</template>

<script lang="ts">
import { Component } from 'vue-property-decorator'
import Vue from 'vue'
import { AppStore } from '~/store/AppStore'
import { AuthStore } from '~/store/AuthStore'
import AppMenu from '~/components/layouts/AppMenu.vue'
import AppToolbar from '~/components/layouts/AppToolbar.vue'
import { ClientesStore } from '~/store/ClientesStore'
import { ProveedoresStore } from '~/store/ProveedoresStore'
import { VeterinariosStore } from '~/store/VeterinariosStore'
import { HistoriasClinicasStore } from '~/store/HistoriasClinicasStore'
import {MascotasStore} from "~/store/MascotasStore";
import {VentasStore} from "~/store/VentasStore";

@Component({
  components: {
    AppToolbar,
    AppMenu
  },
  middleware: 'auth'
})
export default class DefaultLayout extends Vue {
  mostrar: boolean = false;

  get urlActual () {
    return this.$route.name
  }

  get showAppBar () {
    return AppStore.showAppBar
  }

  get drawer ():boolean {
    return AppStore.vermenu
  }

  set drawer (valor:boolean) {
    AppStore.BOTON_MENU(valor)
  }

  get user () {
    return AuthStore.user
  }

  get AppLoading () {
    return AppStore.loading
  }

  get AppLoadingText () {
    return AppStore.loadingText
  }

  mounted () {
    this.mostrar = false
    AppStore.SHOW_LOADING('Cargando...')

    DefaultLayout.descargardatos().then(() => {
      this.mostrar = true
      AppStore.HIDE_LOADING()
    })
  }

  private static descargardatos () {
    return Promise.all([
      ClientesStore.descargarListaClientes(),
      ProveedoresStore.descargarListaProveedores(),
      VeterinariosStore.descargarListaVeterinarios(),
      HistoriasClinicasStore.descargarHistoriaClinicas(),
      MascotasStore.descargarMascotas(),
      VentasStore.descargarListaVentas()
    ])
  }
}
</script>
<style lang="scss">
#app-page-content{
  background-image: url("../static/img/indexBackground.jpg");
  background-size: cover;
  background-repeat: no-repeat;
}
#app-menu{
  //background-color: $menu-back-color;
}
#inspire{
}
</style>
